Summary:	Squid report generator per user/ip/name
Name:		sarg
Version:	2.4.0
Release:	%mkrel 1
License:	GPLv2+
Group:		Monitoring
URL:		http://sarg.sourceforge.net/
Source:		http://prdownloads.sourceforge.net/sarg/%{name}-%{version}.tar.gz
Source1:	sarg.conf.mandriva
BuildRequires:	%{_lib}gd-devel
Requires:	squid, bash

BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Sarg (was Sqmgrlog) generate reports per user/ip/name from SQUID log file.
The reports will be generated in HTML or email.

%prep
%setup -q

%{__chmod} u+wx sarg-php/locale/

%{__perl} -pi.orig -e '
        s|^#(access_log) (.+)$|#$1 $2\n$1 %{_localstatedir}/log/squid/access.log|;
        s|^#(output_dir) (.+)$|#$1 $2\n$1 %{_localstatedir}/www/html/squid/ONE-SHOT|;
        s|^#(resolve_ip) (.+)$|#$1 $2\n$1 yes|;
        s|^#(show_successful_message) (.+)$|#$1 $2\n$1 no|;
        s|^#(mail_utility) (.+)$|#$1 $2\n$1 mail|;
        s|^#(external_css_file) (.+)$|#$1 $2\n$1 %{_localstatedir}/www/html/squid/squid.css|;
    ' sarg.conf

%{__cat} <<'EOF' >sarg.daily
#!/bin/bash

#Get current date
TODAY=$(date +%d/%m/%Y)

#Get one day ago today
YESTERDAY=$(date --date "1 day ago" +%d/%m/%Y)

mkdir -p /var/www/html/squid/daily
chown -R  apache.apache /var/www/html/squid/daily

NAAT="/var/www-naat/html/genfiles/modules/squid-reports/daily"
if [ -d ${NAAT} ]; then
    chown -R apache ${NAAT}
fi

export LC_ALL=C
/usr/bin/sarg -f /etc/sarg/sarg.conf -l /var/log/squid/access.log -o /var/www/html/squid/daily -z -d $YESTERDAY-$TODAY > /dev/null 2>&1
exit 0
EOF

%{__cat} <<'EOF' >sarg.weekly
#!/bin/bash

#Get current date
TODAY=$(date +%d/%m/%Y)

#Get one week ago today
LASTWEEK=$(date --date "1 week ago" +%d/%m/%Y)

mkdir -p /var/www/html/squid/weekly
chown -R apache.apache /var/www/html/squid/weekly

NAAT="/var/www-naat/html/genfiles/modules/squid-reports/weekly"
if [ -d ${NAAT} ]; then
    chown -R apache ${NAAT}
fi

export LC_ALL=C
/usr/bin/sarg -f /etc/sarg/sarg.conf -l /var/log/squid/access.log -o /var/www/html/squid/weekly -z -d $LASTWEEK-$TODAY >/dev/null 2>&1
exit 0
EOF

%{__cat} <<'EOF' >sarg.monthly
#!/bin/bash

#dynamic counter
cnt=1

if [ $cnt -eq 4 ]; then
#Get yesterday date
YESTERDAY=$(date --date "1 day ago" +%d/%m/%Y)
 
#Get 4 weeks ago date
WEEKSAGO=$(date --date "4 weeks ago" +%d/%m/%Y)

mkdir -p /var/www/html/squid/monthly
chown -R apache /var/www/html/squid/monthly

NAAT="/var/www-naat/html/genfiles/modules/squid-reports/monthly "
if [ -d ${NAAT} ]; then
    chown -R apache ${NAAT}
fi

export LC_ALL=C
/usr/bin/sarg -f /etc/sarg/sarg.conf -l /var/log/squid/access.log -o /var/www/html/squid/monthly -d $WEEKSAGO-$YESTERDAY > /dev/null 2>&1
 
/usr/sbin/squid -k rotate

#don't move next line to upper, reason is that sed change the cnt assignment of the first 7 lines
cnt=1
else
let cnt++
fi
#echo Will rename itself \($0\) with cnt \($cnt\) increased. 1>&2
sargtmp=/var/tmp/`basename $0`
sed "1,7s/^cnt=.*/cnt=$cnt/
" $0 >|$sargtmp
chmod -f 775 $sargtmp
mv -f $sargtmp $0
exit 0
EOF

%{__cat} <<EOF >sarg-index.html
<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
    <title>Squid User's Access Report</title>
    <style type="text/css">
        #content         { width:20em; margin-left:auto; margin-right:auto; }
        h1               { color:green; font-size:1.2em; text-align:center; }
        table#reports    { border-collapse:collapse; width:20em; margin-left:auto; margin-right:auto; font-size:0.8em; }
        table#reports td { padding:2px; background-color:#f5f5dc; border:solid white 1px; }
        table#reports th { background-color:#feebcd; border:solid white 1px; color:#00008b; }
    </style>
</head>
<body>

<div id="content">
    <h1>Squid User's Access Report</h1>

    <table summary="" id="reports">
    <tbody>
    <tr>
        <th>DIRECTORY</th>
        <th>DESCRIPTION</th>
    </tr>
    <tr>
        <td><a href="ONE-SHOT/index.html">ONE-SHOT</a></td>
        <td>One shot reports</td>
    </tr>
    <tr>
        <td><a href="daily/index.html">daily</a></td>
        <td>Daily reports</td>
    </tr>
    <tr>
        <td><a href="weekly/index.html">weekly</a></td>
        <td>Weekly reports</td>
    </tr>
    <tr>
        <td><a href="monthly/index.html">monthly</a></td>
        <td>Monthly reports</td>
    </tr>
    </tbody>
    </table>
</div>
</body>
</html>
EOF

%{__cat} <<EOF >sarg-http.conf
Alias /sarg %{_localstatedir}/www/html/squid

<Directory %{_localstatedir}/www/html/squid>
    DirectoryIndex index.html
    Order deny,allow
    Deny from all
    Allow from 127.0.0.1
    Allow from ::1
    # Allow from your-workstation.com
</Directory>
EOF

%build
%configure \
    --enable-bindir=%{_bindir} \
    --enable-sysconfdir=%{_sysconfdir}/sarg \
    --enable-mandir=%{_mandir}/man1 \
    --enable-htmldir=%{_localstatedir}/www/html/squid \
    --disable-rpath

%{__make} LDFLAGS="-Wl,--allow-multiple-definition -lm" %{?_smp_mflags} CFLAGS=-Wno-format

%install
%{__rm} -rf $RPM_BUILD_ROOT
%{__install} -d $RPM_BUILD_ROOT%{_datadir}/%{name}
%{__install} -Dp -m0755 sarg $RPM_BUILD_ROOT%{_bindir}/sarg
# remove original sarg.conf and use the one provided by us
# {__install} -Dp -m0644 sarg.conf $RPM_BUILD_ROOT{_sysconfdir}/sarg/sarg.conf
%{__install} -Dp -m0644 %{SOURCE1} $RPM_BUILD_ROOT/%{_sysconfdir}/%{name}/%{name}.conf

%{__install} -Dp -m0644 exclude_codes $RPM_BUILD_ROOT%{_sysconfdir}/sarg/exclude_codes
%{__install} -Dp -m0644 sarg.1 $RPM_BUILD_ROOT%{_mandir}/man1/sarg.1
%{__install} -Dp -m0644 sarg-http.conf $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/sarg.conf
%{__install} -Dp -m0755 sarg.daily $RPM_BUILD_ROOT%{_sysconfdir}/cron.daily/sarg
%{__install} -Dp -m0755 sarg.weekly $RPM_BUILD_ROOT%{_sysconfdir}/cron.weekly/sarg
%{__install} -Dp -m0755 sarg.monthly $RPM_BUILD_ROOT%{_sysconfdir}/cron.monthly/sarg
%{__install} -Dp -m0644 sarg-index.html $RPM_BUILD_ROOT%{_localstatedir}/www/html/squid/index.html
%{__install} -Dp -m0644 css.tpl $RPM_BUILD_ROOT%{_localstatedir}/www/html/squid/sarg.css


%{__install} -d -m0755 $RPM_BUILD_ROOT%{_localstatedir}/www/html/squid/{ONE-SHOT,daily,weekly,monthly}/
%{__cp} -av fonts/ images/ $RPM_BUILD_ROOT%{_datadir}/%{name}
%find_lang %name
%{__rm} -rf $RPM_BUILD_ROOT%{_sysconfdir}/sarg/languages/.new

%clean
rm -rf $RPM_BUILD_ROOT

%files -f %name.lang
%defattr(-,root,squid)
%doc ChangeLog CONTRIBUTORS COPYING DONATIONS README
%doc %{_mandir}/man1/sarg.1*
%dir %{_sysconfdir}/sarg/
%config %{_sysconfdir}/sarg/exclude_codes
%config(noreplace) %{_sysconfdir}/sarg/sarg.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.d/sarg.conf
%config %{_sysconfdir}/cron.daily/sarg
%config %{_sysconfdir}/cron.weekly/sarg
%config %{_sysconfdir}/cron.monthly/sarg
%{_bindir}/sarg
%{_localstatedir}/www/html/squid/
%{_datadir}/%{name}/fonts/
%{_datadir}/%{name}/images/

%changelog
* Wed Jan 26 2022 yodelu - 2.4.0-1pclos2022
- new

* Fri Mar 15 2019 tex - 2.3.10-2pclos2019
- rebuild against updates
